import psimjava.*;

public class Arrivals extends psimjava.Process {
	private Erand arrivalPeriod;  // cust inter-arrival random num
	private long sleepPeriod;
	public Arrivals(String name,double Mean_arr,long sleepPeriod)
	{
		super(name);
		arrivalPeriod = new Erand(Mean_arr);
		this.sleepPeriod=sleepPeriod;
		//TrafficController.out.println(name+" created at "+get_clock());
	}
	protected void Main_body() {
		double inter_arr;        // inter-arrival period for car object
	   
		//TrafficController.out.println("Arrivals starting main body at: " + get_clock());
	    // repeat until time to close arrivals
	    while(get_clock() <= TrafficController.close_arrival)
	    {
	      inter_arr = arrivalPeriod.fdraw(); // generate inter-arr
	      delay(inter_arr);                  // wait for inter-arr
	      TrafficController.carCount++;
	      
	      //TrafficController.out.println("Arrivals creating Car at: "
	        // + get_clock());
	      Car carobj = new Car("Car" + TrafficController.carCount, "a",sleepPeriod);
	      carobj.start();
	      
	      try{
	    	  Thread.sleep(sleepPeriod);
	      }
	      catch(InterruptedException e){
	    	  
	      }
	      Thread.yield();  // give chance to another thread
	    }
	    /*TrafficController.out.println(TrafficController.NorthRoadQ.length()+" Cars entered the north road.");
	    TrafficController.out.println(TrafficController.EastRoadQ.length()+" Cars entered the east road.");
	    TrafficController.out.println(TrafficController.SouthRoadQ.length()+" Cars entered the south road.");
	    TrafficController.out.println(TrafficController.WestRoadQ.length()+" Cars entered the west road.");
	    TrafficController.out.println("Arrivals terminates");*/
	    terminate();
		

	}

}
