
// import psimjava.Simulation;
// import psimjava.Squeue;
import psimjava.*;
import psimjava.gui.*;
import psimjava.Parameter;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.*;
import java.text.*;
import java.io.*;
import java.util.*;
import java.util.Timer;

public class IntersectPanel extends SimPanel
{
// Sim Params	
//  private JLabel qsizeLabel = new JLabel("Job Queue Capacity:");
  private JLabel simperiodLabel = new JLabel("Simulation Period:"); //keep
  private JLabel closeArrLabel = new JLabel("Close Arrival Period:"); // keep
  private JLabel intArrLabel = new JLabel ("Mean Inter-Arrival Period:"); //keep
//  private JLabel serLabel = new JLabel("Mean Service Period:");
  private JLabel sleepperiodLabel = new JLabel ("Sleep Period:"); //keep
  
  
 // private JTextField qsizeText = new JTextField(5);
  private JTextField simperiodText = new JTextField(5);
  private JTextField closeArrText = new JTextField(5);
  private JTextField intArrText = new JTextField(5);
  private JTextField sleepperiodText = new JTextField(5);
//  private JTextField serText = new JTextField(5);

 // Various Panels 
  private JPanel simParamPanel = new JPanel();
  private JPanel wkLoadParamPanel = new JPanel();
 // private JPanel osParamPanel = new JPanel();
  
  private inSimPanel inSimPanel = new inSimPanel();


// Borders for Panels  
  private TitledBorder simBorder = new TitledBorder("Simulation Parameters");
  private TitledBorder wkLoadBorder = new TitledBorder("WorkLoad Parameters");
  //private TitledBorder osBorder = new TitledBorder("System Parameters");

// Sim Objects
 
  private TrafficController tc;
  private Arrivals arrive;
  

  
  public IntersectPanel()
  {
    super();
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {
    setupSimParamPanel();
    setupWkLoadParamPanel();
    //setupCWParamPanel();
 

    setupIsectPanel();
    setDefaults();
  }

  public void setDefaults()
  {
  //  qsizeText.setText("" + 55);
    simperiodText.setText("" + 3700d);
    closeArrText.setText("" + 340d);
    intArrText.setText("" + 5d);
    sleepperiodText.setText(""+1000d);
   // serText.setText("" + 4.2);
  }

  public void runSim()
  {
      /*
	  TrafficController.out.println("Cars with mean arrival: " +
    		  TrafficController.MeanInterarrival + " and service: " + TrafficController.MeanServiceDur);
      TrafficController.wash_machine.start();
     */
      tc.start();
//      arrive.start();
      Thread.yield();
      
      inSimPanel.startSim(tc);
      
      TimerTask reDraw = new TimerTask() {
		    public void run() { inSimPanel.removeAll(); inSimPanel.validate(); inSimPanel.repaint(); }
		};	
      Timer timer = new Timer();
      timer.scheduleAtFixedRate(reDraw, 100, 100);
     
  }

  public void setOutputStream(OutputStream out)
  {
    TrafficController.out = new PrintStream(out);
  }

  public void setNull()
  {
	//TrafficController.wash_machine = null;
    arrive = null;
    tc = null;
    //TrafficController.car_queue = null;
   // TrafficController.sim = null;
  }

  public boolean setValues()
  {
    NumberFormat nf = NumberFormat.getInstance();
    String s;
    double d;
    int i;
    long l;
    Number num;

    try{
    	/*
        s = qsizeText.getText();
        num = nf.parse(s);
        i = num.intValue();
        Carwash.totalQSize = i;
		*/
    	
        s = intArrText.getText();
        num = nf.parse(s);
        d = num.doubleValue();
        TrafficController.req_arr_mean = d;
        long arrivalper = (long)d;
        
        /*s = serText.getText();
        num = nf.parse(s);
        d = num.doubleValue();
        Carwash.MeanServiceDur = d;
		*/
        
        s = closeArrText.getText();
        num = nf.parse(s);
        d = num.doubleValue();
        TrafficController.close_arrival = d;
       

        s = simperiodText.getText();
        num = nf.parse(s);
        d = num.doubleValue();
        TrafficController.sim_period = d;

        s = sleepperiodText.getText();
        num = nf.parse(s);
        d = num.doubleValue();
        long sleepPeriod = (long)d;

        TrafficController.run = new Simulation("Intersection Sim");
        
        //arrive = new Arrivals("Arrivals", TrafficController.req_arr_mean, TrafficController.sleepperiod );
        
        tc = new TrafficController("Intersection Simulation", sleepPeriod, arrivalper);
        // cwshop.start(); // 10-13-01
      }catch(ParseException e)
        {
          return false;
        }
    
   
    return true;
  }

  private void setupIsectPanel()
  {
    GridBagLayout gbl = new GridBagLayout();
    setLayout(gbl);
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.fill = gbc.HORIZONTAL;
    gbc.anchor = gbc.WEST;
    gbc.gridx = 0;
    gbc.gridy = 0;
   // add(osParamPanel, gbc);
    gbc.gridy = 1;
    add(wkLoadParamPanel, gbc);
    gbc.gridy = 2;
    add(simParamPanel, gbc);
    gbc.gridy = 3;
    add(inSimPanel, gbc);
    setBorder(new TitledBorder("Intersection Simulation"));

  }
  

  
  private void setupSimParamPanel()
  {
    GridBagLayout gbl = new GridBagLayout();
    simParamPanel.setLayout(gbl);
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.insets = new Insets(1, 5, 1, 5);
    gbc.anchor = gbc.EAST;
    gbc.gridx = 0;
    gbc.gridy = 0;
    simParamPanel.add(closeArrLabel, gbc);
    gbc.gridy = 1;
    simParamPanel.add(simperiodLabel, gbc);
    gbc.gridy = 2;
    simParamPanel.add(sleepperiodLabel, gbc);
    gbc.gridx = 1;
    gbc.gridy = 0;
    simParamPanel.add(closeArrText, gbc);
    gbc.gridy = 1;
 
    simParamPanel.add(simperiodText, gbc);
    gbc.gridy = 2;
   
    simParamPanel.add(sleepperiodText, gbc);
    simParamPanel.setBorder(simBorder);
  }

  private void setupWkLoadParamPanel()
  {
    GridBagLayout gbl = new GridBagLayout();
    wkLoadParamPanel.setLayout(gbl);
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.insets = new Insets(1, 5, 1, 5);
    gbc.anchor = gbc.EAST;
    gbc.gridx = 0;
    gbc.gridy = 0;
    wkLoadParamPanel.add(intArrLabel, gbc);
    gbc.gridy = 1;
    wkLoadParamPanel.add(closeArrLabel, gbc);
    gbc.gridy =2;
 //   wkLoadParamPanel.add(serLabel, gbc);
    gbc.gridx = 1;
    gbc.gridy = 0;
    //gbc.anchor = gbc.WEST;
    wkLoadParamPanel.add(intArrText, gbc);
    gbc.gridy = 1;
    wkLoadParamPanel.add(closeArrText, gbc);
    //gbc.gridy = 2;
 //   wkLoadParamPanel.add(serText, gbc);
    wkLoadParamPanel.setBorder(wkLoadBorder);
  }
/*
  private void setupCWParamPanel()
  {
    GridBagLayout gbl = new GridBagLayout();
    osParamPanel.setLayout(gbl);
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.insets = new Insets(1, 5, 1, 5);
    gbc.anchor = gbc.EAST;
    gbc.gridx = 0;
    gbc.gridy = 0;
    osParamPanel.add(qsizeLabel, gbc);
    gbc.gridy = 1;
    // osParamPanel.add(totmemLabel, gbc);
    gbc.gridy = 2;
    // osParamPanel.add(mem_uLabel, gbc);
    gbc.gridy = 3;
    // osParamPanel.add(mem_lLabel, gbc);
    gbc.gridx = 1;
    gbc.gridy = 0;
  //  gbc.anchor = gbc.WEST;
    osParamPanel.add(qsizeText, gbc);
    gbc.gridy = 1;
    // osParamPanel.add(totmemText, gbc);
    gbc.gridy = 2;
    // osParamPanel.add(mem_uText, gbc);
    gbc.gridy = 3;
    // osParamPanel.add(mem_lText,gbc);
    osParamPanel.setBorder(osBorder);
  }
*/
  public double getSimPeriod()
  {
    return TrafficController.sim_period;
  }

  public SimResults getResults()
  {
	  /*
    // Parameter p0 = new Parameter("Service factor",
    //         new Double((Carwash.acc_proc / Carwash.acc_sojourn_t)));
    // Parameter p1 = new Parameter("Machine utilization",
    //        new Double((Carwash.custServiceTime/Carwash.simperiod)));
    Parameter p2 = new Parameter("Total cars arrived",
            new Integer(Carwash.num_arrived));
    Parameter p3 = new Parameter("Total cars rejected",
            new Integer(Carwash.num_rejected));
    Parameter p4 = new Parameter("Total cars serviced",
            new Integer(Carwash.num_serviced));
    // Parameter p5 = new Parameter("Proportiion Rejected", new Double(
    //           ((double)Carwash.rejected/(double)Carwash.arrived)));
    Parameter p6 = new Parameter("Average Car Wait Period", new Double(
              (Carwash.custWaitTime/(double)Carwash.num_serviced)));
	*/
	  
    SimResults sr = new SimResults("Intersection Sim", "Intersection Sim");
    /*
    // sr.addResult(p0);
    // sr.addResult(p1);
    sr.addResult(p2);
    sr.addResult(p3);
    sr.addResult(p4);
    // sr.addResult(p5);
    sr.addResult(p6);
    // sr.addResult(p7);
	*/
    
    return sr;
  }
  
}
