import psimjava.*;

public class Road extends psimjava.Process {
	
	public Squeue roadIn;
	public int carInCount=0;
	public int carOutCount=0;
	public Squeue roadOut;
	public  TrafficLight.Light lightColor;
	private Erand arrivalPeriod;
	public int carCount;
	private long sleepPeriod;
	private double carPop;
	public Road(String name,int roadQueueLength,double Mean_Arrival,long sleepPeriod)
	{
		super(name);
		this.sleepPeriod=sleepPeriod;
		roadIn = new Squeue(getName()+" IN",roadQueueLength);
		roadOut = new Squeue(getName()+" OUT",roadQueueLength);
		lightColor = TrafficLight.Light.RED;
		arrivalPeriod = new Erand(Mean_Arrival);
		carPop = 1d;
	}
	public void Main_body()
	{
		double inter_arr;     
		
		TrafficController.out.println(getName()+" starting main body at: " + get_clock());
		while(get_clock() <= TrafficController.close_arrival)
	    {
			inter_arr = arrivalPeriod.fdraw(); // generate inter-arr
		    delay(inter_arr);  
		    TrafficController.carCount++;
		    this.carCount++;
		    this.carInCount++;
		    
			Car carobj = new Car("Car" + TrafficController.carCount,get_name(),sleepPeriod);
			carobj.start();
			
			roadIn.into(carobj);
			if(lightColor == TrafficLight.Light.GREEN && carInCount > 0)
			{
				delay(carPop);
				TrafficController.out.println("Car is leaving from the "+get_name()+" going "+carobj.getTurnDirectionName());
				if(this.get_name() == "North Road"){
					if(carobj.turnDirection == 1)
					{
						this.carInCount--;
						TrafficController.EastRoad.carOutCount++;
					}
					else if(carobj.turnDirection == 2)
					{
						this.carInCount--;
						TrafficController.SouthRoad.carOutCount++;
					}
					else if(carobj.turnDirection ==3)
					{
						this.carInCount--;
						TrafficController.WestRoad.carOutCount++;
					}
				}
				else if(this.get_name() == "East Road"){
					if(carobj.turnDirection == 1)
					{
						this.carInCount--;
						TrafficController.SouthRoad.carOutCount++;
					}
					else if(carobj.turnDirection == 2)
					{
						this.carInCount--;
						TrafficController.WestRoad.carOutCount++;
					}
					else if(carobj.turnDirection ==3)
					{
						this.carInCount++;
						TrafficController.NorthRoad.carOutCount++;
					}
				}
				else if(this.get_name() == "South Road"){
					if(carobj.turnDirection == 1)
					{
						this.carInCount++;
						TrafficController.WestRoad.carOutCount++;
					}
					else if(carobj.turnDirection == 2)
					{
						this.carInCount++;
						TrafficController.NorthRoad.carOutCount++;
					}
					else if(carobj.turnDirection ==3)
					{
						this.carInCount++;
						TrafficController.EastRoad.carOutCount++;
					}
				}
				else if(this.get_name() == "West Road"){
					if(carobj.turnDirection == 1)
					{
						this.carInCount++;
						TrafficController.NorthRoad.carOutCount++;
					}
					else if(carobj.turnDirection == 2)
					{
						this.carInCount++;
						TrafficController.EastRoad.carOutCount++;
					}
					else if(carobj.turnDirection ==3)
					{
						this.carInCount++;
						TrafficController.SouthRoad.carOutCount++;
					}
				}
				
			}
			try{
		    	  Thread.sleep(sleepPeriod);
		      }
		      catch(InterruptedException e){
		    	 
		      }
		      Thread.yield();
	    }
		
		Thread.yield();		
		TrafficController.out.println("Car Count: "+this.carCount);
		terminate();
	}
	public int getRoadInCount()
	{
		return carInCount;
	}
	public int getRoadOutCount()
	{
		return carOutCount;
	}
	public TrafficLight.Light getLightColor()
	{
		return lightColor;
	}
	public void setLightColor(TrafficLight.Light color)
	{
		lightColor = color;
	}
	
}
