/**
 * 
 */

/**
 * @author csigler
 *
 */
import java.io.PrintStream;
import psimjava.*;

public class TrafficController extends psimjava.Process {
	public static double sim_period;      // simulation time period
    public static double close_arrival;  // close time for arrival
    public static double req_arr_mean;   // request arrival period mean
    
    public static Simulation run;
    public static PrintStream out = System.out;
    public static Arrivals tarrivals;
    public static int carCount;
    
    public static Intersection roadIntersection;
    public static Road NorthRoad;
    public static Road EastRoad;
    public static Road SouthRoad;
    public static Road WestRoad;
    
    public static TrafficController contr;
    private long sleepPeriod;
    private double meanArrival;
    
	public TrafficController(String name,long sleepPeriod,double meanArrival)
	{
		super(name);
		this.sleepPeriod=sleepPeriod;
		this.meanArrival=meanArrival;
	}
	public void Main_body()
	{	
		roadIntersection = new Intersection("Intersection",sleepPeriod,20,5);
		
		NorthRoad = new Road("North Road",50000,meanArrival,sleepPeriod);
		NorthRoad.start();
		EastRoad = new Road("East Road",50000,meanArrival,sleepPeriod);
		EastRoad.start();
		SouthRoad = new Road("South Road",50000,meanArrival,sleepPeriod);
		SouthRoad.start();
		WestRoad = new Road("West Road",50000,meanArrival,sleepPeriod);
		WestRoad.start();
		
		
		run.start_sim(sim_period);
		
	//	System.exit(0); //comment out if gui
		
	}
	public static void main(String[] args) 
	{
		
		run = new Simulation("Traffic Intersection Simulation");
		sim_period = 370d;
		req_arr_mean = 5d;
		close_arrival = 340d;
		double mean_arrival=10d;
		carCount = 0;
		long templong = 10;
		contr = new TrafficController("Traffic Controller",templong,mean_arrival);
		contr.start();
		
		Thread.yield();
		
		
		
	}

}
