//--------------------------------------//
// The model of the traffic intersection model.
// Modeled by Chad Sigler and Todd Dickerson, December 2007.
//
// This will represent a traffic light with
// three colors, RED,YELLOW,GREEN; to
// be used in an intersection.  
// 
//--------------------------------------//
public class TrafficLight {

	private Light currLight;
	public enum Light
	{
		RED,YELLOW,GREEN
	}
	
	public TrafficLight(Light lightColor)
	{
		currLight = lightColor;
	}
	public Light changeLight()
	{
		
		switch(currLight)
		{
		case RED : 	
					currLight = Light.GREEN;
					break;
		case YELLOW : 
					currLight = Light.RED;					
					break;
		case GREEN : 
					currLight = Light.YELLOW;					
					break;
		default:	
					break;
		}
		return currLight;
	}
	public Light getLightColor()
	{		
		return currLight;
	}
	public void setLightColor(Light newLight)
	{
		currLight = newLight;
	}
}
