package psimjava;
import java.awt.*;
import java.text.DecimalFormat;
/**
 * <p> Class to paint an image of a clock for animations</p>
 */
//
//	ClockGraphic class by M.E.Shaw
//	modified 3/9/01

public class ClockGraphic {
    private static final int qh = 50;
    private Rectangle location;
    private double simTime;
    private double simperiod;
    private String mssgSimPeriod;
    private String mssgSimTime = "Time elapsed: " + 0;
    private static final DecimalFormat f = new DecimalFormat("#");
    /**
     * Class to paint an image of a clock for animations
     * @param x int - x position for the clock
     * @param y int - y position for the clock
     * @param simp double - Simulation Period
     */
    public ClockGraphic(int x, int y, double simp) {
        location = new Rectangle(x - qh, y, qh, qh);
        simperiod = simp;
        mssgSimPeriod = "Time set    : " + f.format(simperiod);
    }
    /**
     * paint method called periodically to redraw the clock
     * @param g Graphics
     */
    public void paint(Graphics g) {

        int x = location.x;
        int y = location.y;

        g.setColor(Color.black);
        g.drawOval(x, y, qh, qh);

        g.drawString(mssgSimPeriod, x - 20, y - 10);
        simTime = Model.getCurrentClock();
        mssgSimTime = "Time elapsed: " + f.format(simTime);
        g.drawString(mssgSimTime, x - 20, y + qh + 15);

        g.setColor(Color.red);
        int arcAngle = (int) (simTime * 360 / simperiod);
        g.fillArc(x, y, qh, qh, 90, -arcAngle);
        g.setColor(Color.black);
    }
}
