package psimjava;
import java.util.Random;
import java.util.Calendar;
/**
 *
 * <p> Exponential Randum Number Generator </p>
 * <P>Object-oriented simulation package, process interaction approach.
 * <P> (C) J. M. Garrido. June 2000, 2003, 2004
 * Random number generator, Exponential distribution </p>
 */

public class Erand {
    //
    private double fmean;
    private Random egen;
    /**
     * Constructor for initializing the exponential random number generator.
     * @param emean double, the mean value of the distribution
     * @param eseed long, the seed value for selecting a random stream.
     */
    public Erand(double emean, long eseed) {
        if (emean < 0.0)
           emean = 1.0;
        egen = new Random(eseed);
        fmean = emean;
    }
    /**
     * Constructor for initializing the exponential random number generator.
     * @param emean double, the mean value of the distribution
     */
    public Erand(double emean) {
       /*
        long defseed; // default seed
        Calendar cal = Calendar.getInstance();
        defseed = cal.get(Calendar.SECOND);
        defseed += cal.get(Calendar.MILLISECOND);
        egen = new Random(defseed);
       */
        if (emean < 0.0)
           emean = 1.0;   
        egen = new Random();  // default seed
        fmean = emean;
    }

    /**
     * This function generates a random number using the exponential
     * distribution with the mean value given in the constructor.
     * @return double, a random number.
     */
    public double fdraw() {
        double myex;
        myex = egen.nextDouble();
        while (myex == 0.0d)
          myex = egen.nextDouble();
        myex = -fmean * Math.log(myex);
        return myex;
    }
}
