package psimjava;

/**
 * PsimJ Java package for OO simulation
 * <P>Object-oriented simulation package, process interaction approach.
 * <P> (C) J. M. Garrido. June 2000, 2003, 2004
 *
 * <P>File: Pobject.java
 */
public class Pobject
    extends Thread {
    static final int MAX_PRIORITIES = 350;
    static final int INT_COMM_TIMER = 350; // int level for comm timer
    static final int OBJECT = 0;
    static final int TASK = 2;
    static final int QHEAD = 3;
    static long error_fct; // for error reporting
    private int p_priority; // user priority
    private int ao_type; // OBJECT, TIMER, TASK, QUEUE
    Pobject o_next; // next process in list
    private static int in_error = 0; // error indicator
    private static String error_name[] = {
        "",
        "Object has chain",
        "object is on chain",
        "queue is empty",
        "object on other queue",
        "queue is full",
        "object on other queue", // qtail
        "queue is full",
        "clock not zero",
        "clock process not idle",
        "process terminated",
        "process is running",
        "clock has neg time",
        "process or timer on other queue",
        "bad arguments for histogram",
        "stack overflow",
        "free store exhausted",
        "bad mode on creation",
        "process not terminated",
        "process not running",
        "timer not terminated",
        "bad value of time",
        "bad object",
        "queue not empty",
        "process self result",
        "process wait for self",
        "number of req bin items",
        "number of created processes",
        "timing error",
        "number of req res items",
        "number of released items",
        "number of running processes too big",
        "bad arguments",
        "number of priorities too big"
    };
    // error codes
    static final int E_OLINK = 1;
    static final int E_ONEXT = 2;
    static final int E_GETEMPTY = 3;
    static final int E_PUTOBJ = 4;
    static final int E_PUTFULL = 5;
    static final int E_BACKOBJ = 6;
    static final int E_BACKFULL = 7;
    static final int E_SETCLOCK = 8;
    static final int E_CLOCKIDLE = 9;
    static final int E_RESTERM = 10;
    static final int E_RESRUN = 11;
    static final int E_NEGTIME = 12;
    static final int E_RESOBJ = 13;
    static final int E_HISTO = 14;
    static final int E_STACK = 15;
    static final int E_STORE = 16;
    static final int E_TASKMODE = 17;
    static final int E_TASKDEL = 18;
    static final int E_TASKPRE = 19;
    static final int E_TIMERDEL = 20;
    static final int E_SCHTIME = 21;
    static final int E_SCHOBJ = 22;
    static final int E_QDEL = 23;
    static final int E_RESULT = 24;
    static final int E_WAIT = 25;
    static final int E_BINNRR = 26;
    static final int E_PRNUMEX = 27;
    static final int E_PRTIM = 28;
    static final int E_RESRI = 29;
    static final int E_RESREL = 30;
    static final int E_PRRMX = 31;
    static final int E_SIMARG = 32;
    static final int E_WTQMPR = 33;
    static final int MAXERR = E_WAIT;
    //
    // member functions (methods)
    public Pobject(int type_obj) { // constructor
        ao_type = type_obj; // type of object
        o_next = null;
        p_priority = 0;
    }

    int o_type() {
        return ao_type;
    }

    static void print_error(int n) {
        System.out.println(" *** Process error " + n);
        System.out.println(error_name[n]);
    }

    static int process_error(int n) {
        /* if ( in_error > 0)
         System.exit(in_error);
               else
         in_error = n;
               if (error_fct > 0) {
         if (n > 0) System.exit(n);
               }
               else {
         */
        print_error(n);
        System.exit(n);
        // }
        in_error = 0;
        return 0;
    }

    public void set_prio(int prio) { // set user priority
        p_priority = prio;
    }

    public int get_prio() { // get user priority
        return p_priority;
    }
} // end of Pobject class
