package psimjava;

/**
 * <p>Plots the size of a RequestProcessor's queue</p>
 *
 * @author Rich Schlesinger
 * @version 1.0
 */
public class QPlotter extends Plotter {
    private RequestProcessor server;
    /**
     * Create a Plot for the specified RequestProcessor's queue
     * @param title String
     * @param yAxisLabel String
     * @param legend String[]
     * @param x int
     * @param y int
     * @param simIn Input
     * @param server RequestProcessor
     */
    public QPlotter(String title,
                   String yAxisLabel,
                   String[] legend,
                   int x,
                   int y,
                   Input simIn,
                   RequestProcessor server) {
        super(title,yAxisLabel,legend,x,y,simIn);
        this.server = server;
    }
    ////////////////////////////////////////////////////////////////////////////
    /**
     * Get the current size of the queue
     * @return int
     */
    public int getPlotY() {
        return server.getNumberWaitingRequests();
    }
    ////////////////////////////////////////////////////////////////////////////
    /**
     * Returns the scale to be used in the plot
     * @return int
     */
    public int getScale() {
        return 10;
    }

}
