package psimjava;

/**
 * <p>Class implementing the concept of a Request process</p>
 *
 * <p>Copyright: Copyright (c) 2004-2005</p>
 *
 * @author Rich Schlesinger
 * @version 1.0
 */
public class Request extends psimjava.Process {
    /**
     * Request needs Exclusive Access to the RequestProcessor
     */
    public static int EXCLUSIVE_ACCESS = 1;
    /**
     * Request will use Shared Access to the RequestProcessor
     */
    public static int SHARED_ACCESS = 2;

    private int priority = 1;
    private int requestType = EXCLUSIVE_ACCESS;
    private double waitStartTime;
    ////////////////////////////////////////////////////////////////////////////
    public Request(String name) {
        super(name);
    }
    ////////////////////////////////////////////////////////////////////////////
    /**
     * Set the priority level of a Request. Zero is highest priority
     * @param priority int
     */
    public void setRequestPriority(int priority) {
        this.priority = priority;
    }
    ////////////////////////////////////////////////////////////////////////////
    /**
     * Get the current priority level of a Request
     * @return int
     */
    public int getRequestPriority() {
        return priority;
    }
    ////////////////////////////////////////////////////////////////////////////
    /**
     * Set the Request type
     * @param type int
     */
    public void setRequestType(int type) {
        requestType = type;
    }
    ////////////////////////////////////////////////////////////////////////////
    /**
     * Gets the request type
     * @return int
     */
    public int getRequestType() {
        return requestType;
    }
    ////////////////////////////////////////////////////////////////////////////
    /**
    * Set the time that the Request began waiting
    * @param time double
    */

    public void setWaitStartTime(double time) {
        waitStartTime = time;
    }
    ////////////////////////////////////////////////////////////////////////////
    /**
     * Get the time at which the Request began waiting
     * @return double
     */
    public double getWaitStartTime() {
        return waitStartTime;
    }
    ////////////////////////////////////////////////////////////////////////////
    public void Main_body() {

    }
}
