package psimjava;
import java.awt.*;

/**
 * <p> Create a graphic for a RequestProcessor's Schedular Queue</p>
 *
 * <p>Copyright: Copyright (c) 2004-2005</p>
 *
 * @author Rich Schlesinger
 * @version 1.0
 */
public class SchedularGraphic extends QGraphic {
    RequestProcessor sched;
    /**
     * Creates a Graphic for a RequestProcessor Queue
     * @param x int
     * @param y int
     * @param orientation Dimension
     * @param sched RequestProcessor
     */
    public SchedularGraphic(int x, int y, Dimension orientation, RequestProcessor sched) {
        super(x,y, orientation);
        this.sched = sched;
    }
    ////////////////////////////////////////////////////////////////////////////
    /**
     * Returns the current length of the RequestProcessor's queue
     * @return int
     */
    protected int getQLength() {
        return sched.getNumberWaitingRequests();
    }
}
