package psimjava;

//
/**
 * Internal class in PsimJ.
 * <P>Object-oriented simulation package, process interaction approach.
 * (C) Jose M. Garrido, June 2000, August 2003, 2004
 * <P>This class uses Java's wait/notify mechanism.
 */
class Suspend
    extends Object {
    // Object for synchronizing Wait/notify
    // for Deactivate/Activate of processes
    // The sus_state variable is similar to the 's_state' member in the
    // Psim processes. When the value is true and the calling process is
    // the running process, the process is suspended.
    // Method 'proceed' will notify all waiting processes

    // private Object prlock;
    private boolean sus_state; // true when the process suspends
    //
    public Suspend() { // constructor
        // print("((Suspend) creating Suspend object, time: "+
        //      StaticSync.get_clock());
        // prlock = new Object();
        sus_state = false; // process does not suspend
    }

    //
    // sets flag that represents state
    public void set_flag(boolean sflag) {
        sus_state = sflag;
    }

    //
    // gets value of flag rep state
    public boolean get_flag() {
        return sus_state;
    }

    //
    // A process must wait if sus_state is true and it is not the
    // running process
    // public synchronized void suswait ( Process p ) throws InterruptedException {
    public synchronized void suswait() throws InterruptedException {
        Process pprun = (Process) StaticSync.this_process();
        // print ("in suswait, running: "+pprun.get_name());
        while (sus_state != false) {
            //     && ((Process) StaticSync.this_process()) != p)
            //       || (p.rdstate() != Sched.RUNNING )) {
            /*
                      print ("To wait state: "+p.get_name()+ " at " +
                StaticSync.get_clock()+" proc running?: "
                + (((Process)StaticSync.this_process()) == p));
             print ("suswait: "+p.get_name()+ " sus_state: "+sus_state +
             " cond "+((sus_state != false
                      && ((Process)StaticSync.this_process()) != p)
                      || p.rdstate() != Sched.RUNNING));
             print(" running: "+ ((Process) StaticSync.this_process()).get_name()+
             " rdstate: " +p.rdstate());
             */
            wait();
            //       print ("back from wait "+p.get_name());
        }
        // }
        // print ("exiting suswait ");  // +p.get_name());
    }

    //
    public synchronized void proceed() {
        // synchronized (prlock ) {
        // print ("In proceed ");
        sus_state = false; // process can proceed
        notify(); // signal all processes waiting
        // print ("exiting proceed");
        // }
    }

    //
    private static void print(String msg) {
        System.out.println(msg);
    }
}
