package psimjava.gui;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class PsimTextArea extends JTextArea
{
  private OutputStream out = new PsimOutputStream();

  private Observable ob = new PsimObserverable();


  public PsimTextArea()
  {
    super(10, 45);
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {

    setToolTipText("Trace for Simulation");
    setEditable(false);
    setBorder(new EtchedBorder());
  }

  public void addObserver(Observer obsv)
  {
    ob.addObserver(obsv);
  }

  public OutputStream getOutputStream()
  {
    return out;
  }
/*
  public Dimension getMinimumSize()
  {
    return new Dimension(72, 200);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(60*8, getLineCount()*12);
  }
*/
  class PsimOutputStream extends OutputStream
  {
    public synchronized void write(int b)
    {
      //convert int to byte
      b &= 0x000000FF;

      //convert byte to a char
      char c = (char) b;
      append(String.valueOf(c));
      ob.notifyObservers();
    }

    public synchronized void write(byte[] b, int offset, int length)
    {
      append(new String(b, offset, length));
      ob.notifyObservers();
    }
  }

  class PsimObserverable extends Observable
  {

    public PsimObserverable()
    {
      super();
    }

    public void notifyObservers()
    {
      //set state as having be changed, so hasChanged returns true
      setChanged();
      super.notifyObservers();
    }

  }
}

