   package psimjava.gui;

   import java.util.*;
   import javax.swing.*;

   import javax.swing.table.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.io.*;


    public class ResultsDialog extends JDialog
   {
      private ArrayList<SimResults> results;
      private JTable table;
      private JPanel topPanel;
      private ResultsTableData rtd;
      private JMenuBar menuBar;
   
      private JFileChooser chooser;
   
      private boolean standAlone = true;
   
       public ResultsDialog()
      {
         this(true);
      }
       public ResultsDialog(boolean standAlone)
      {
         this.standAlone = standAlone;
         results = new ArrayList<SimResults> ();
         rtd = new ResultsTableData();
         table = new JTable(rtd);
         table.setAutoCreateColumnsFromModel(false);
         topPanel = new JPanel(new BorderLayout());
      
         JScrollPane sp = new JScrollPane(table);
      
         topPanel.add(sp,BorderLayout.CENTER);
         this.getContentPane().add(topPanel);
         this.setSize(400, 400);
         setupChooser();
         setupMenu();
         this.setJMenuBar(menuBar);
      }
   
       private void setupMenu()
      {
         menuBar = new JMenuBar();
         JMenu menuFile = new JMenu("File");
         menuFile.setMnemonic('f');
      
         ImageIcon iconOpen = new ImageIcon("open.gif");
         Action actionOpen = 
             new AbstractAction("Open...", iconOpen){
                public void actionPerformed(ActionEvent e){
                  fileOpen_ActionPerformed(e);
               }
            };
      
         JMenuItem item = menuFile.add(actionOpen);
         item.setMnemonic('o');
         item.setIcon(null);
         menuFile.addSeparator();
      
         ImageIcon iconSave = new ImageIcon("closefile.gif");
         Action actionSave = 
             new AbstractAction("Save...", iconSave){
                public void actionPerformed(ActionEvent e){
                  fileSave_ActionPerformed(e);
               }
            };
      
         item = menuFile.add(actionSave);
         item.setMnemonic('s');
         item.setIcon(null);
      
         menuFile.addSeparator();
      
         Action actionExit = 
             new AbstractAction("Exit"){
                public void actionPerformed(ActionEvent e){
                  fileExit_ActionPerformed(e);
               }
            };
      
         item = menuFile.add(actionExit);
         item.setMnemonic('x');
      
         menuBar.add(menuFile);
      }
   
       private void setupChooser()
      {
         chooser = new JFileChooser();
      
      
         javax.swing.filechooser.FileFilter ff2 = chooser.getAcceptAllFileFilter();
         chooser.removeChoosableFileFilter(ff2);
      
         javax.swing.filechooser.FileFilter ff = new ResultsFileFilter();
         chooser.addChoosableFileFilter(ff);
      }
       public static void main(String[] args)
      {
      
         Param p1 = new Param("test1", new Double(32.555555555553));
         Param p2 = new Param("test2", new Integer(2));
         SimResults sr = new SimResults("Tester", "testname");
         SimResults sr2 = new SimResults("Tester 2", "test2Name");
         sr.addResult(p1);
         sr.addResult(p2);
         sr2.addResult(p1);
         sr2.addResult(p2);
         ResultsDialog resultsDialog = new ResultsDialog();
         resultsDialog.addResults(sr);
         resultsDialog.addResults(sr2);
         resultsDialog.setVisible(true);
      }
   
       private void fileSave_ActionPerformed(ActionEvent e)
      {
      
      }
   
       private void fileOpen_ActionPerformed(ActionEvent e)
      {
      
      }
   
       private void fileExit_ActionPerformed(ActionEvent e)
      {
         this.setVisible(false);
         if(standAlone == true)
         {
            this.dispose();
            System.exit(0);
         }
      }
   
   
       public void addResults(SimResults r)
      {
         int numCol = rtd.getColumnCount();
         results.add(r);
      
         if(numCol == 0)
         {
            DefaultTableCellRenderer render = new DefaultTableCellRenderer();
            render.setHorizontalAlignment(JLabel.LEFT);
            TableColumn tc = new TableColumn(numCol, 150, render, null);
            tc.setHeaderValue(rtd.getColumnName(numCol));
            table.addColumn(tc);
            numCol++;
         }
         DefaultTableCellRenderer render2 = new DefaultTableCellRenderer();
         render2.setHorizontalAlignment(JLabel.RIGHT);
         TableColumn tc = new TableColumn(numCol, 100, render2, null);
         tc.setHeaderValue(rtd.getColumnName(numCol));
         tc.setMinWidth(25);
         table.addColumn(tc);
      //createColumns();
      //table.createDefaultColumnsFromModel();
      }
   
       class ResultsTableData extends AbstractTableModel
      {
      
          public int getRowCount()
         {
            if(results.isEmpty())
            {
               return 0;
            }
            else
            {
               SimResults sr = (SimResults)results.get(0);    // firstElement();
               Param p[] = sr.getResults();
               return p.length;
            }
         }
      
          public int getColumnCount()
         {
            if(results.isEmpty())
               return 0;
            else
               return results.size() + 1;
         }
      
          public Object getValueAt(int row, int column)
         {
            if(column == 0)
            {
               SimResults sr = (SimResults)results.get(0);   // firstElement();
               Param p[] = sr.getResults();
               return p[row].getName();
            }
            else
            {
               column--;    //subtract 1 for param name column
               SimResults sr = (SimResults)results.get(column);
               Param p[] = sr.getResults();
               return p[row].getValue();
            }
         }
      
          public String getColumnName(int column)
         {
            if(column == 0)
            {
               return new String("Output Parameters");
            }
            else
            {
               column--;     //subtract 1 for param name column
               SimResults sr = (SimResults)results.get(column);
               return sr.getTitle();
            }
         }
      
          public String getTitle()
         {
            return "Simulation Results";
         }
      
          public boolean isCellEditable(int row, int column)
         {
            return false;
         }
      }//ResultsTableData
       class ResultsFileFilter extends javax.swing.filechooser.FileFilter
      {
      
         private String description = new String("Simulation Results");
         private String extension = new String(".psr");
      
          public boolean accept(File f)
         {
            if(f == null)
               return false;
            if(f.isDirectory())
               return true;
            return f.getName().toLowerCase().endsWith(extension);
         }
          public String getDescription()
         {
            return description;
         }
      }
   
   
   }
