   package psimjava.gui;
   import java.io.*;


    public class XMLResultsWriter
   {
      SimResults sr;
      File f;
      BufferedWriter bw;
      FileWriter fw;
   
       public XMLResultsWriter(File f, SimResults sr)
      {
         this.f = f;
         this.sr = sr;
         try
         {
            fw = new FileWriter(f);
            bw = new BufferedWriter(fw);
            writeResults();
         }
             catch(IOException e)
            {}
      
      }
   
       private void writeResults() throws IOException
      {
         bw.write("<?xml version=\"1.0\"?>\r\n");
         bw.write("<SimResults type=\"" + sr.getType() + "\" title=\""
                                        + sr.getTitle() + "\">\r\n" );
         Param p[] = sr.getResults();
         for(int j = 0; j < p.length; j++)
         {
            writeParam(p[j]);
         }
         bw.write("</SimResults>\r\n");
         bw.flush();
      
      }
       private void writeParam(Param p) throws IOException
      {
         String type;
         if(p.getValue() instanceof Integer)
            type = "Integer";
         else if(p.getValue() instanceof Long)
            type = "Long";
         else
            type = "Double";
         bw.write("<Param name=\"" + p.getName() + "\" type=\"" + type +"\">");
         bw.write(p.getValue() + "</Param>\r\n");
      }
       public static void main(String[] args)
      {
         Param p[] = new Param[5];
         p[0] = new Param("first", new Integer(1));
         p[1] = new Param("second", new Double(222.2222));
         p[2] = new Param("third", new Double(33.3333333333));
         p[3] = new Param("fourth", new Integer(4));
         p[4] = new Param("5th", new Integer(5));
         SimResults sr = new SimResults("Tester1", "testing1", p);
         XMLResultsWriter xrw = new XMLResultsWriter(new File("xmlResults.psr"),sr);
      }
   }